' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2006                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2006/12/07 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft


Public Class frmMain

    '͈
    Private m_ExeRegion As New FvRectangle

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'ݒpRg[̏
        cmbSearchMode.Items.Add("ʏ̃p^[")   ' NORMAL_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' BLACK_LINE_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' WHITE_LINE_PATTERN"
        cmbSearchMode.Items.Add("sp^[")   ' UNSTABLE_PATTERN"
        cmbSearchMode.SelectedIndex = 0

        cmbPrecision.Items.Add("ʏ퐸x") ' NORMAL_MODE"
        cmbPrecision.Items.Add("x")   ' HIGH_MODE"
        cmbPrecision.Items.Add("x") ' SUPER_MODE"
        cmbPrecision.SelectedIndex = 2

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'J摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub
    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - txtResult.Height - 55
            AxFvxDisplayEx1.Size = newSize

            txtResult.Width = AxFvxDisplayEx1.Width
            txtResult.Top = AxFvxDisplayEx1.Top + AxFvxDisplayEx1.Height + 10
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    's
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim pSearchResultGroup As New FvSearchResultGroup
        Dim pSearchResult As New FvSearchResult
        Dim pPoint As New FvPoint
        Dim dblTime As Double
        Dim intCount As Integer

        Dim intTemp As Integer
        Dim i As Integer


        AxFvxDisplayEx1.ClearOverlay()

        'p[^ݒ
        AxFvxCorrelation1.SetInspectArea(m_ExeRegion)                   '͈
        AxFvxCorrelation1.SearchMode = cmbSearchMode.SelectedIndex    'T[`[hiׂȂǂ̃p^[Ɏgpj
        AxFvxCorrelation1.Precision = cmbPrecision.SelectedIndex      'T[`

        '摜̏
        If Integer.TryParse(txtCondition.Text, intTemp) = False Or intTemp < 1 Or intTemp > 9 Then
            MsgBox("Ԃ 1`9 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.Condition = intTemp

        '臒l
        If Integer.TryParse(txtThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("XRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.ScoreThresh = intTemp

        'r臒l
        If Integer.TryParse(txtMiddleThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("rXRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.ScoreThresh2 = intTemp

        'T[`
        If Integer.TryParse(txtSearchNum.Text, intTemp) = False Or intTemp < 1 Then
            MsgBox("p[^sł", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.SearchNum = intTemp

        '͈͐ڐGĂ̂o邩ǂ
        If chkWndTouch.Checked = True Then
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.OFF
        End If


        Try
            'ԌvJn
            AxFvxPerformanceCounter1.StartCount()

            'p^[ݒ
            AxFvxCorrelation1.SetPattern(AxFvxPattern1.GetOcx())

            'T[`s
            AxFvxCorrelation1.Execute(AxFvxImage1.GetOcx(), intCount)

            'ԌvI
            AxFvxPerformanceCounter1.StopCount(dblTime)

            '͈͂ŕ\
            AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

            'T[`ʂԂŕ\
            AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
            AxFvxDisplayEx1.FontColor = System.Drawing.Color.FromArgb(0, 0, 255)

            txtResult.Text = " : " & VisualBasic.Format(dblTime, "0.00ms") & vbCrLf & vbCrLf & _
                             "T[` : " & VisualBasic.Format(intCount) & vbCrLf & " No      X      Y   score" & vbCrLf

            AxFvxCorrelation1.GetResult(0, pSearchResultGroup)
            AxFvxDisplayEx1.DrawData(0, pSearchResultGroup)

            For i = 0 To pSearchResultGroup.Count - 1
                pSearchResult = pSearchResultGroup.Item2(i)
                pPoint.x = pSearchResult.x
                pPoint.y = pSearchResult.y
                AxFvxDisplayEx1.DrawText(0, pPoint, i.ToString())
                txtResult.Text = txtResult.Text & VisualBasic.Format(i, "000  ") & _
                    VisualBasic.Format(pSearchResult.x, "000.0  ") & _
                    VisualBasic.Format(pSearchResult.y, "000.0   ") & _
                    VisualBasic.Format(pSearchResult.score, "000") & vbCrLf
            Next
        Catch ex As Exception
            Dim intErr As Integer
            AxFvxCorrelation1.GetErrReport(intErr)
            MsgBox(GetCorrelationErrMesg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    Public Function GetCorrelationErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetCorrelationErrMesg = "G["
            Case 5001
                GetCorrelationErrMesg = "p^݂Ă܂B"
            Case 5005
                GetCorrelationErrMesg = "p[^Ⴂ܂B"
            Case 5006
                GetCorrelationErrMesg = "^Ⴂ܂B"
            Case 5007
                GetCorrelationErrMesg = "p^摜̂߁Ao^ł܂B"
            Case 5008
                GetCorrelationErrMesg = "p^ƃ}XÑTCYvĂ܂B"
            Case 5009
                GetCorrelationErrMesg = "p[^NULLlw肳܂B"
            Case 5010
                GetCorrelationErrMesg = "̊mۂɎs܂B"
            Case 5022
                GetCorrelationErrMesg = "p^w肳Ă܂B"
            Case Else
                GetCorrelationErrMesg = "sȃG["
        End Select

    End Function

    Public Function GetPatternErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetPatternErrMesg = "G["
            Case 9502
                GetPatternErrMesg = "T|[gĂȂC[W^CvłB"
            Case 9505
                GetPatternErrMesg = "p[^Ⴂ܂B"
            Case 9506
                GetPatternErrMesg = "̌^Ⴂ܂B"
            Case 9510
                GetPatternErrMesg = "̊mۂɎs܂B"
            Case 9531
                GetPatternErrMesg = "pX̎w肪ԈĂ܂B"
            Case 9533
                GetPatternErrMesg = "p^[݂܂B"
            Case 9540
                GetPatternErrMesg = "p^݂܂B"
            Case Else
                GetPatternErrMesg = "sȃG["
        End Select

    End Function

    'p^[o^
    Private Sub btnSetPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPattern.Click

        Dim pRect As New FvRectangle    'p^[̈̐ݒ
        Dim pPoint As New FvPoint       'p^[_

        Dim intOK As Integer
        Dim dblTemp As Double

        'o^̏`ݒ
        pRect.xs = 100
        pRect.ys = 100
        pRect.xe = 200
        pRect.ye = 200
        AxFvxROI2.SetRectangle(pRect)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI2.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI2.CheckRectangle = 1 Then
            AxFvxROI2.GetRectangle(pRect)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If pRect.xe < pRect.xs Then
                dblTemp = pRect.xs
                pRect.xs = pRect.xe
                pRect.xe = dblTemp
            End If
            If pRect.ye < pRect.ys Then
                dblTemp = pRect.ys
                pRect.ys = pRect.ye
                pRect.ye = dblTemp
            End If

            If AxFvxROI2.CheckPoint = 1 Then
                AxFvxROI2.GetPoint(pPoint)
            Else
                MsgBox("p^[_w肳܂łB" & vbCr & "p^[`̒S_Ƃēo^܂", , "p^[o^")

                pPoint.x = (pRect.xs + pRect.xe) / 2
                pPoint.y = (pRect.ys + pRect.ye) / 2
            End If

            AxFvxPattern1.MakePattern(AxFvxImage1.GetOcx(), pRect, pPoint)
        End If

    End Sub

    'p^[̃}XNݒ
    Private Sub btnSetPatternMask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPatternMask.Click

        AxFvxPattern1.DefMask()

    End Sub

    'p^[\
    Private Sub btnDispPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPattern.Click

        AxFvxPattern1.Disp()

    End Sub

    'p^[t@C̓Ǎ
    Private Sub btnLoadPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadPattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        OpenFileDialog1.DefaultExt = "*.pat"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.LoadPattrenFileName = OpenFileDialog1.FileName
                AxFvxPattern1.Load()
            Catch ex As Exception
                MsgBox("p^[Ǎݎs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'p^[t@C̕ۑ
    Private Sub btnSavePattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSavePattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        SaveFileDialog1.DefaultExt = "*.pat"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.SavePattrenFileName = SaveFileDialog1.FileName
                AxFvxPattern1.Save()
            Catch ex As Exception
                MsgBox("p^[ۑs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If
        End If

    End Sub

    Private Sub txtCondition_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtCondition.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    Private Sub txtThreshold_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtThreshold.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    Private Sub txtMiddleThreshold_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtMiddleThreshold.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    Private Sub txtSearchNum_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtSearchNum.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
